-- ===============================================
-- Author	  : FID.Intan	  
-- Create date: 15-Desember-2014
-- Description:	Insert Data to TB_T_DVL_FI_JOURNAL for INV
-- Bug ID	  : 493
-- ===============================================

CREATE PROCEDURE [dbo].[SP_PROTO_INSERT_DVL_FI_JOURNAL_INV]
	@PROCESS_ID BIGINT,
	@DOC_NO VARCHAR(15),
	@DOC_YEAR VARCHAR(4),
	@INV_NO VARCHAR(20),
	@DOC_ITEM VARCHAR(5),
	@TRANSACTION_CD VARCHAR(3),
	@CONDITION_TYPE VARCHAR(5),
	@DC_INDICATOR VARCHAR(1),
	@GL_ACCOUNT VARCHAR(10),
	@EXCHANGE_RATE DECIMAL,
	@LOCAL_CURR VARCHAR(3),
	@PO_NO VARCHAR(11),
	@DOC_TYPE VARCHAR(2),
	@BILLING_STS VARCHAR(1)
AS
DECLARE
	@AMT_DOC NUMERIC(18, 0),
	@USERID VARCHAR(20),
	@CREATED_DT VARCHAR(20),
	@INV_DT VARCHAR(20),
	@TAX_CD VARCHAR(2)
BEGIN
	--Get Tax CD
	SELECT @TAX_CD = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_TAX_CD_LIV'

	SELECT @PO_NO = MAX(PO_NO) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO
	SELECT TOP 1 @USERID = CONVERT(VARCHAR(20), UPDATE_BY) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND PO_NO = @PO_NO AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS
	SELECT TOP 1 @CREATED_DT = MAX(UPDATE_DT) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND PO_NO = @PO_NO AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS
	SELECT TOP 1 @INV_DT = MAX(INV_DT) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND PO_NO = @PO_NO AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS
	
	IF(@BILLING_STS = '4')
	BEGIN
		IF(@DOC_ITEM = '1')
		BEGIN
			INSERT INTO TB_T_DLV_FI_JOURNAL 
			SELECT DISTINCT @DOC_NO AS DOC_NO, 
				   @DOC_YEAR AS DOC_YEAR, 
				   ISNULL((SELECT ISNULL(COUNT(DOC_NO),0) from TB_T_DLV_FI_JOURNAL WITH (HOLDLOCK, UPDLOCK) WHERE DOC_NO = @DOC_NO AND PROCESS_ID = @PROCESS_ID),0) 
					+ DENSE_RANK() OVER (ORDER BY INV_NO) AS DOC_ITEM, 
				   CASE WHEN (@INV_DT = '') THEN GETDATE() ELSE @INV_DT END AS DOC_DT, 
				   @TRANSACTION_CD AS TRANSACTION_CD, 
				   @CONDITION_TYPE AS CONDITION_TYPE, 
				   @DC_INDICATOR AS DEBIT_CREDIT_INDICATOR, 
				   SUBSTRING(SUPPLIER_NO, 1, 4) AS GL_ACCOUNT,
				   NULL AS ROUTE_CD, 
				   NULL AS QTY, 
				   CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, '', 'D3', @BILLING_STS)) * (-1) AS AMT_DOC, 
				   CONVERT(VARCHAR(3), CURR_CD) AS DOC_CURR,
				   CONVERT(NUMERIC(18, 0), CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, '', 'D3', @BILLING_STS)) * (-1)) * @EXCHANGE_RATE AS LOCAL_AMT,
				   @LOCAL_CURR AS LOCAL_CURR,
				   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID) AS PO_NO,
				   @TAX_CD AS TAX_CD,
				   @EXCHANGE_RATE AS EXCHANGE_RATE,
				   NULL AS COST_CENTER_CD,
				   @DOC_TYPE AS DOC_TYPE,
				   NULL AS GL_BALANCE_FLAG,
				   (SELECT MAX(BUDGET_NO) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS AND PO_NO = [dbo].[fn_PROTO_GET_PO_NO](MAX(A.DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID)) AS WBS_NO,
				   NULL AS UOM,
				   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID) AS ITEM_TEXT,
				   @USERID AS CREATED_BY,
				   @CREATED_DT AS CREATED_DT,
				   NULL AS CHANGED_BY,
				   NULL AS CHANGED_DT,
				   @PROCESS_ID AS PROCESS_ID
			FROM TB_T_PROTO_INV A WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS 
			--GROUP BY BILLING_STS, SUPPLIER_NO, CURR_CD, BUDGET_NO, UPDATE_BY, UPDATE_DT, PROCESS_ID, INV_NO, INV_DT ORDER BY PO_NO
			GROUP BY BILLING_STS, SUPPLIER_NO, CURR_CD, BUDGET_NO, PROCESS_ID, INV_NO ORDER BY PO_NO
		END
		ELSE IF(@DOC_ITEM = '2')
		BEGIN
			SELECT @AMT_DOC = CONVERT(NUMERIC(18, 0), SUM(CONVERT(NUMERIC(15, 3), PO_AMT))) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO
			INSERT INTO TB_T_DLV_FI_JOURNAL 
			SELECT DISTINCT @DOC_NO AS DOC_NO, 
				   @DOC_YEAR AS DOC_YEAR, 
				   '' AS DOC_ITEM, 
				   CASE WHEN (@INV_DT = '') THEN GETDATE() ELSE @INV_DT END AS DOC_DT, 
				   @TRANSACTION_CD AS TRANSACTION_CD, 
				   @CONDITION_TYPE AS CONDITION_TYPE, 
				   @DC_INDICATOR AS DEBIT_CREDIT_INDICATOR, 
				   @GL_ACCOUNT AS GL_ACCOUNT,
				   NULL AS ROUTE_CD, 
				   NULL AS QTY, 
				   CONVERT(NUMERIC(15,3), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, DELIVERY_NOTE_NO, 'D10', BILLING_STS)) AS DOC_AMT,
				   CONVERT(VARCHAR(3), CURR_CD) AS DOC_CURR,
				   CONVERT(NUMERIC(18, 0), CONVERT(NUMERIC(15,3), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, DELIVERY_NOTE_NO, 'D10', BILLING_STS)) * @EXCHANGE_RATE) AS LOCAL_AMT,
				   @LOCAL_CURR AS LOCAL_CURR,
				   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV', '', '', @PROCESS_ID) AS PO_NO,
				   @TAX_CD AS TAX_CD,
				   @EXCHANGE_RATE AS EXCHANGE_RATE,
				   NULL AS COST_CENTER_CD,
				   @DOC_TYPE AS DOC_TYPE,
				   NULL AS GL_BALANCE_FLAG,
				   (SELECT MAX(BUDGET_NO) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS AND PO_NO = [dbo].[fn_PROTO_GET_PO_NO](MAX(A.DELIVERY_NOTE_NO), 'INV', @INV_NO, @BILLING_STS, @PROCESS_ID)) AS WBS_NO,
				   NULL AS UOM,
				   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV', '', '', @PROCESS_ID) AS ITEM_TEXT,
				   @USERID AS CREATED_BY,
				   @CREATED_DT AS CREATED_DT,
				   NULL AS CHANGED_BY,
				   NULL AS CHANGED_DT,
				   @PROCESS_ID AS PROCESS_ID
			FROM TB_T_PROTO_INV A WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS 
			--GROUP BY BILLING_STS, SUPPLIER_NO, CURR_CD, BUDGET_NO, UPDATE_BY, UPDATE_DT, PROCESS_ID, INV_NO, INV_DT, DELIVERY_NOTE_NO ORDER BY PO_NO
			GROUP BY BILLING_STS, SUPPLIER_NO, CURR_CD, BUDGET_NO, PROCESS_ID, INV_NO, DELIVERY_NOTE_NO ORDER BY PO_NO
		END
		ELSE IF(@DOC_ITEM = '3')
		BEGIN
			SELECT @AMT_DOC = MAX(CONVERT(NUMERIC(18, 0), TAX_AMT)) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO
			INSERT INTO TB_T_DLV_FI_JOURNAL 
			SELECT DISTINCT @DOC_NO AS DOC_NO, 
				   @DOC_YEAR AS DOC_YEAR, 
				   ISNULL((SELECT ISNULL(COUNT(DOC_NO),0) from TB_T_DLV_FI_JOURNAL WITH (HOLDLOCK, UPDLOCK) WHERE DOC_NO = @DOC_NO AND PROCESS_ID = @PROCESS_ID),0) 
					+ DENSE_RANK() OVER (ORDER BY INV_NO) AS DOC_ITEM, 
				   CASE WHEN (@INV_DT = '') THEN GETDATE() ELSE @INV_DT END AS DOC_DT, 
				   @TRANSACTION_CD AS TRANSACTION_CD, 
				   @CONDITION_TYPE AS CONDITION_TYPE, 
				   @DC_INDICATOR AS DEBIT_CREDIT_INDICATOR, 
				   @GL_ACCOUNT AS GL_ACCOUNT,
				   NULL AS ROUTE_CD, 
				   NULL AS QTY, 
				   CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, '', 'D2', BILLING_STS)) AS DOC_AMT, 
				   CONVERT(VARCHAR(3), CURR_CD) AS DOC_CURR,
				   CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, '', 'D2', BILLING_STS)) * @EXCHANGE_RATE AS LOCAL_AMT,
				   @LOCAL_CURR AS LOCAL_CURR,
				   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID) AS PO_NO,
				   NULL AS TAX_CD,
				   @EXCHANGE_RATE AS EXCHANGE_RATE,
				   NULL AS COST_CENTER_CD,
				   @DOC_TYPE AS DOC_TYPE,
				   NULL AS GL_BALANCE_FLAG,
				   (SELECT MAX(BUDGET_NO) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS AND PO_NO = [dbo].[fn_PROTO_GET_PO_NO](MAX(A.DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID)) AS WBS_NO,
				   NULL AS UOM,
				   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID) AS ITEM_TEXT,
				   @USERID AS CREATED_BY,
				   @CREATED_DT AS CREATED_DT,
				   NULL AS CHANGED_BY,
				   NULL AS CHANGED_DT,
				   @PROCESS_ID AS PROCESS_ID
			FROM TB_T_PROTO_INV A WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS 
			--GROUP BY BILLING_STS, SUPPLIER_NO, CURR_CD, BUDGET_NO, UPDATE_BY, UPDATE_DT, PROCESS_ID, INV_NO, INV_DT ORDER BY PO_NO
			GROUP BY BILLING_STS, SUPPLIER_NO, CURR_CD, BUDGET_NO, PROCESS_ID, INV_NO ORDER BY PO_NO
		END
	END
	ELSE IF(@BILLING_STS = '3')
	BEGIN
		IF(@DOC_ITEM = '1')
		BEGIN
			SELECT @PO_NO = MAX(PO_NO) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO
			SELECT @CONDITION_TYPE = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_CONDITION_TYPE_DEBIT'
			INSERT INTO TB_T_DLV_FI_JOURNAL 
			SELECT DISTINCT @DOC_NO AS DOC_NO, 
				   @DOC_YEAR AS DOC_YEAR, 
				   ISNULL((SELECT ISNULL(COUNT(DOC_NO),0) from TB_T_DLV_FI_JOURNAL WITH (HOLDLOCK, UPDLOCK) WHERE DOC_NO = @DOC_NO AND PROCESS_ID = @PROCESS_ID),0) 
					+ DENSE_RANK() OVER (ORDER BY INV_NO) AS DOC_ITEM, 
				   CASE WHEN (@INV_DT = '') THEN GETDATE() ELSE @INV_DT END AS DOC_DT, 
				   @TRANSACTION_CD AS TRANSACTION_CD, 
				   @CONDITION_TYPE AS CONDITION_TYPE, 
				   @DC_INDICATOR AS DEBIT_CREDIT_INDICATOR, 
				   @GL_ACCOUNT AS GL_ACCOUNT,
				   NULL AS ROUTE_CD, 
				   NULL AS QTY, 
				   CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, '', 'D1', @BILLING_STS)) AS AMT_DOC, 
				   CONVERT(VARCHAR(3), CURR_CD) AS DOC_CURR,
				   CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, '', 'D1', @BILLING_STS)) * @EXCHANGE_RATE AS AMT_LOCAL,
				   @LOCAL_CURR AS LOCAL_CURR,
				   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID) AS PO_NO,
				   @TAX_CD AS TAX_CD,
				   @EXCHANGE_RATE AS EXCHANGE_RATE,
				   NULL AS COST_CENTER_CD,
				   @DOC_TYPE AS DOC_TYPE,
				   NULL AS GL_BALANCE_FLAG,
				   (SELECT MAX(BUDGET_NO) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS AND PO_NO = [dbo].[fn_PROTO_GET_PO_NO](MAX(A.DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID)) AS WBS_NO,
				   NULL AS UOM,
				   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID) AS ITEM_TEXT,
				   @USERID AS CREATED_BY,
				   @CREATED_DT AS CREATED_DT,
				   NULL AS CHANGED_BY,
				   NULL AS CHANGED_DT,
				   @PROCESS_ID AS PROCESS_ID
			FROM TB_T_PROTO_INV A WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS 
			--GROUP BY BILLING_STS, SUPPLIER_NO, CURR_CD, BUDGET_NO, UPDATE_BY, UPDATE_DT, PROCESS_ID, INV_NO, INV_DT ORDER BY PO_NO
			GROUP BY BILLING_STS, SUPPLIER_NO, CURR_CD, BUDGET_NO, PROCESS_ID, INV_NO ORDER BY PO_NO
		END
		ELSE IF(@DOC_ITEM = '2')
		BEGIN
			SELECT @AMT_DOC = CONVERT(NUMERIC(18, 0), SUM(CONVERT(NUMERIC(15, 3), PO_AMT))) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO
			INSERT INTO TB_T_DLV_FI_JOURNAL 
			SELECT DISTINCT @DOC_NO AS DOC_NO, 
				   @DOC_YEAR AS DOC_YEAR, 
				   '' AS DOC_ITEM, 
				   CASE WHEN (@INV_DT = '') THEN GETDATE() ELSE @INV_DT END AS DOC_DT, 
				   @TRANSACTION_CD AS TRANSACTION_CD, 
				   @CONDITION_TYPE AS CONDITION_TYPE, 
				   @DC_INDICATOR AS DEBIT_CREDIT_INDICATOR, 
				   SUBSTRING(SUPPLIER_NO, 1, 4) AS GL_ACCOUNT,
				   NULL AS ROUTE_CD, 
				   NULL AS QTY, 
				   CONVERT(NUMERIC(15,3), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, DELIVERY_NOTE_NO, 'D20', BILLING_STS)) * (-1) AS AMT_DOC, 
				   CONVERT(VARCHAR(3), CURR_CD) AS DOC_CURR,
				   CONVERT(NUMERIC(15,3), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, DELIVERY_NOTE_NO, 'D20', BILLING_STS)) * (-1) * @EXCHANGE_RATE AS AMT_LOCAL,
				   @LOCAL_CURR AS LOCAL_CURR,
				   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV', '', '', @PROCESS_ID) AS PO_NO,
				   @TAX_CD AS TAX_CD,
				   @EXCHANGE_RATE AS EXCHANGE_RATE,
				   NULL AS COST_CENTER_CD,
				   @DOC_TYPE AS DOC_TYPE,
				   NULL AS GL_BALANCE_FLAG,
				   (SELECT MAX(BUDGET_NO) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS AND PO_NO = [dbo].[fn_PROTO_GET_PO_NO](MAX(A.DELIVERY_NOTE_NO), 'INV', @INV_NO, @BILLING_STS, @PROCESS_ID)) AS WBS_NO,
				   NULL AS UOM,
				   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV', '', '', @PROCESS_ID) AS ITEM_TEXT,
				   @USERID AS CREATED_BY,
				   @CREATED_DT AS CREATED_DT,
				   NULL AS CHANGED_BY,
				   NULL AS CHANGED_DT,
				   @PROCESS_ID AS PROCESS_ID
			FROM TB_T_PROTO_INV A WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS 
			--GROUP BY BILLING_STS, SUPPLIER_NO, CURR_CD, BUDGET_NO, UPDATE_BY, UPDATE_DT, PROCESS_ID, INV_NO, INV_DT, DELIVERY_NOTE_NO ORDER BY PO_NO
			GROUP BY BILLING_STS, SUPPLIER_NO, CURR_CD, BUDGET_NO, PROCESS_ID, INV_NO, DELIVERY_NOTE_NO ORDER BY PO_NO
		END
		ELSE IF(@DOC_ITEM = '3')
		BEGIN
			SELECT @AMT_DOC = CONVERT(NUMERIC(18, 0), SUM(CONVERT(NUMERIC(15, 3), TAX_AMT))) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO
			INSERT INTO TB_T_DLV_FI_JOURNAL 
			SELECT DISTINCT @DOC_NO AS DOC_NO, 
				   @DOC_YEAR AS DOC_YEAR, 
				   ISNULL((SELECT ISNULL(COUNT(DOC_NO),0) from TB_T_DLV_FI_JOURNAL WITH (HOLDLOCK, UPDLOCK) WHERE DOC_NO = @DOC_NO AND PROCESS_ID = @PROCESS_ID),0) 
					+ DENSE_RANK() OVER (ORDER BY INV_NO) AS DOC_ITEM, 
				   CASE WHEN (@INV_DT = '') THEN GETDATE() ELSE @INV_DT END AS DOC_DT, 
				   @TRANSACTION_CD AS TRANSACTION_CD, 
				   @CONDITION_TYPE AS CONDITION_TYPE, 
				   @DC_INDICATOR AS DEBIT_CREDIT_INDICATOR, 
				   @GL_ACCOUNT AS GL_ACCOUNT,
				   NULL AS ROUTE_CD, 
				   NULL AS QTY, 
				   CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, '', 'D3', BILLING_STS)) * (-1) AS AMT_DOC, 
				   CONVERT(VARCHAR(3), CURR_CD) AS DOC_CURR,
				   CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT_INV](@INV_NO, @PROCESS_ID, '', 'D3', BILLING_STS)) * (-1) * @EXCHANGE_RATE AS AMT_LOCAL,
				   @LOCAL_CURR AS LOCAL_CURR,
				   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID) AS PO_NO,
				   NULL AS TAX_CD,
				   @EXCHANGE_RATE AS EXCHANGE_RATE,
				   NULL AS COST_CENTER_CD,
				   @DOC_TYPE AS DOC_TYPE,
				   NULL AS GL_BALANCE_FLAG,
				   (SELECT MAX(BUDGET_NO) FROM TB_T_PROTO_INV WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS AND PO_NO = [dbo].[fn_PROTO_GET_PO_NO](MAX(A.DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID)) AS WBS_NO,
				   NULL AS UOM,
				   [dbo].[fn_PROTO_GET_PO_NO](MAX(DELIVERY_NOTE_NO), 'INV2', @INV_NO, @BILLING_STS, @PROCESS_ID) AS ITEM_TEXT,
				   @USERID AS CREATED_BY,
				   @CREATED_DT AS CREATED_DT,
				   NULL AS CHANGED_BY,
				   NULL AS CHANGED_DT,
				   @PROCESS_ID AS PROCESS_ID
			FROM TB_T_PROTO_INV A WHERE PROCESS_ID = @PROCESS_ID AND INV_NO = @INV_NO AND BILLING_STS = @BILLING_STS 
			--GROUP BY BILLING_STS, SUPPLIER_NO, CURR_CD, BUDGET_NO, UPDATE_BY, UPDATE_DT, PROCESS_ID, INV_NO, INV_DT ORDER BY PO_NO
			GROUP BY BILLING_STS, SUPPLIER_NO, CURR_CD, BUDGET_NO, PROCESS_ID, INV_NO ORDER BY PO_NO
		END
	END

	UPDATE x
	SET x.DOC_ITEM = x.RN
	FROM (
		  SELECT DOC_ITEM, ROW_NUMBER() OVER (ORDER BY DOC_NO) AS RN
		  FROM TB_T_DLV_FI_JOURNAL where doc_no = @DOC_NO
      ) x
END

